- Qt 6.8
- Qt 3D
- C++ Classes
- Qt3DExtras (Deprecated)
- QConeGeometry
- Qt 6.8.2 Reference Documentation

# QConeGeometry Class

class Qt3DExtras::QConeGeometry

The QConeGeometry class allows creation of a cone in 3D space. More...

Header: | `#include <Qt3DExtras/QConeGeometry>`
CMake: | `find_package(Qt6 REQUIRED COMPONENTS 3dextras)` `target_link_libraries(mytarget PRIVATE Qt6::3dextras)`
qmake: | `QT += 3dextras`
In QML: | ConeGeometry
Inherits: | Qt3DCore::QGeometry
Status: | Deprecated

- List of all members, including inherited members

## Properties

bottomRadius : float hasBottomEndcap : bool hasTopEndcap : bool indexAttribute : Qt3DCore::QAttribute* const length : float normalAttribute : Qt3DCore::QAttribute* const | positionAttribute : Qt3DCore::QAttribute* const rings : int slices : int texCoordAttribute : Qt3DCore::QAttribute* const topRadius : float

## Public Functions

float | bottomRadius() const
bool | hasBottomEndcap() const
bool | hasTopEndcap() const
Qt3DCore::QAttribute * | indexAttribute() const
float | length() const
Qt3DCore::QAttribute * | normalAttribute() const
Qt3DCore::QAttribute * | positionAttribute() const
int | rings() const
int | slices() const
Qt3DCore::QAttribute * | texCoordAttribute() const
float | topRadius() const
void | updateIndices()
void | updateVertices()

## Public Slots

void | setBottomRadius(float bottomRadius)
void | setHasBottomEndcap(bool hasBottomEndcap)
void | setHasTopEndcap(bool hasTopEndcap)
void | setLength(float length)
void | setRings(int rings)
void | setSlices(int slices)
void | setTopRadius(float topRadius)

## Signals

void | bottomRadiusChanged(float bottomRadius)
void | hasBottomEndcapChanged(bool hasBottomEndcap)
void | hasTopEndcapChanged(bool hasTopEndcap)
void | lengthChanged(float length)
void | ringsChanged(int rings)
void | slicesChanged(int slices)
void | topRadiusChanged(float topRadius)

## Detailed Description

The QConeGeometry class is most commonly used internally by the QConeMesh but can also be used in custom Qt3DRender::QGeometryRenderer subclasses. The class allows for creation of both a cone and a truncated cone.

## Property Documentation

### bottomRadius : float

Holds the bottom radius of the cone.

Access functions:

float | bottomRadius() const
void | setBottomRadius(float bottomRadius)

Notifier signal:

void | bottomRadiusChanged(float bottomRadius)

### hasBottomEndcap : bool

Determines if the cone bottom is capped or open.

Access functions:

bool | hasBottomEndcap() const
void | setHasBottomEndcap(bool hasBottomEndcap)

Notifier signal:

void | hasBottomEndcapChanged(bool hasBottomEndcap)

### hasTopEndcap : bool

Determines if the cone top is capped or open.

Access functions:

bool | hasTopEndcap() const
void | setHasTopEndcap(bool hasTopEndcap)

Notifier signal:

void | hasTopEndcapChanged(bool hasTopEndcap)

### `[read-only]` indexAttribute : Qt3DCore::QAttribute* const

Holds the geometry index attribute.

Access functions:

Qt3DCore::QAttribute * | indexAttribute() const

### length : float

Holds the length of the cone.

Access functions:

float | length() const
void | setLength(float length)

Notifier signal:

void | lengthChanged(float length)

### `[read-only]` normalAttribute : Qt3DCore::QAttribute* const

Holds the geometry normal attribute.

Access functions:

Qt3DCore::QAttribute * | normalAttribute() const

### `[read-only]` positionAttribute : Qt3DCore::QAttribute* const

Holds the geometry position attribute.

Access functions:

Qt3DCore::QAttribute * | positionAttribute() const

### rings : int

Holds the number of rings in the geometry.

Access functions:

int | rings() const
void | setRings(int rings)

Notifier signal:

void | ringsChanged(int rings)

### slices : int

Holds the number of slices in the geometry.

Access functions:

int | slices() const
void | setSlices(int slices)

Notifier signal:

void | slicesChanged(int slices)

### `[read-only]` texCoordAttribute : Qt3DCore::QAttribute* const

Holds the geometry texture coordinate attribute.

Access functions:

Qt3DCore::QAttribute * | texCoordAttribute() const

### topRadius : float

Holds the top radius of the cone.

Access functions:

float | topRadius() const
void | setTopRadius(float topRadius)

Notifier signal:

void | topRadiusChanged(float topRadius)

## Member Function Documentation

### void QConeGeometry::updateIndices()

Updates indices based on geometry properties.

### void QConeGeometry::updateVertices()

Updates vertices based on geometry properties.